module RDF
  class URI
    ##
    # @return [RDF::Util::Cache]
    # @private
    def self.cache
      require 'rdf/util/cache' unless defined?(::RDF::Util::Cache)
      @cache ||= {}
      @cache[@graph] ||= RDF::Util::Cache.new(CACHE_SIZE)
    end
    
    def self.intern(str)
      (cache[@graph][str = str.to_s] ||= self.new(str)).freeze
    end    
    
    def graph=(graph)
      raise ArgumentError unless graph.is_a?(::RDF::Graph)
      if !self.frozen? && graph != self.graph
        @graph = graph
      elsif self.frozen? && graph != self.graph
        new_uri = self.dup
        self = new_uri
        @graph = graph
      end        
    end
  end
end